﻿$PSCmds = @(

"Get-Service | SELECT *",

"Get-Process | SELECT *",

"New-Item -Path 'C:\PSTest\Test.txt' -ItemType File"

)

$res = AsyncPowershell $PSCmds "Server01" "Administrator" "PASSWORD"

function AsyncPowershell($Cmds, $Server, $AdminAccount, $AdminPassword) 
{
    try {
        $MaxRunspace = $Cmds.Length

        $SecurePassword = ConvertTo-SecureString $AdminPassword -AsPlainText -Force
        $Cred = New-Object -TypeName System.Management.Automation.PSCredential -ArgumentList $AdminAccount, $SecurePassword;
        $RunspaceConnectionInfo = New-Object System.Management.Automation.Runspaces.WSManConnectionInfo
        $RunspaceConnectionInfo.Credential = $Cred

        $RunspaceConnectionInfo.ComputerName = $Server
        $RunspacePool = [RunspaceFactory]::CreateRunspacePool(1, $MaxRunspace, $RunspaceConnectionInfo)        
	    $RunspacePool.Open()
	    
        $aryPowerShell  = New-Object System.Collections.ArrayList
        $aryIAsyncResult  = New-Object System.Collections.ArrayList
        for ( $i = 0; $i -lt $MaxRunspace; $i++ )
        {
            $Cmd = $Cmds[$i]
            $PowerShell = [PowerShell]::Create()
	        $PowerShell.RunspacePool = $RunspacePool
            $PowerShell.AddScript($Cmd)
            $PowerShell.AddCommand("Out-String")
            $IAsyncResult = $PowerShell.BeginInvoke()
                       
            $aryPowerShell.Add($PowerShell)
            $aryIAsyncResult.Add($IAsyncResult)
        }

        while ( $aryPowerShell.Count -gt 0 )
        {
            for ( $i = 0; $i -lt $aryPowerShell.Count; $i++ )
            {
                $PowerShell = $aryPowerShell[$i]
                $IAsyncResult = $aryIAsyncResult[$i]    

                if($PowerShell -ne $null)
                {
                    if($IAsyncResult.IsCompleted)
                    {
                        $Result = $PowerShell.EndInvoke($IAsyncResult)
                        Write-host $Result
                        $PowerShell.Dispose()
                        $aryPowerShell.RemoveAt($i)
                        $aryIAsyncResult.RemoveAt($i)
                        {break outer}
                    }
                }           
            }
            Start-Sleep -Milliseconds 100
        }
    } catch [Exception] {
        Write-Host $_.Exception.Message; 
    } finally {
        $RunspacePool.Close()
    }
}